/*
 *   $Id$
 *
 *   Copyright 2008 Glencoe Software, Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 */

package ome.util;

import org.hibernate.HibernateException;
import org.hibernate.MappingException;
import org.hibernate.cache.CacheException;
import org.hibernate.cache.spi.access.CollectionRegionAccessStrategy;
import org.hibernate.collection.spi.PersistentCollection;
import org.hibernate.engine.spi.SharedSessionContractImplementor;
import org.hibernate.mapping.Collection;
import org.hibernate.persister.collection.BasicCollectionPersister;
import org.hibernate.persister.collection.CollectionPersister;
import org.hibernate.persister.spi.PersisterCreationContext;

import java.io.Serializable;

/**
 * {@link CollectionPersister} which knows how to handle the count views
 * generated by dsl/resources/ome/dsl/views.dm. In general, attempts to data
 * modifications and properly loads the counts.
 */
public class CountCollectionPersister extends BasicCollectionPersister {

//    public CountCollectionPersister(Collection collection,
//                                    CollectionRegionAccessStrategy regions, Configuration cfg,
//                                    SessionFactoryImplementor factory) {
//        super(collection, regions, cfg, factory);
//    }

    public CountCollectionPersister(Collection collectionBinding,
                                    CollectionRegionAccessStrategy cacheAccessStrategy,
                                    PersisterCreationContext creationContext) throws MappingException, CacheException {
        super(collectionBinding, cacheAccessStrategy, creationContext);
    }

    @Override
    public void insertRows(PersistentCollection collection, Serializable id, SharedSessionContractImplementor session) throws HibernateException {
        // Do nothing
    }

    @Override
    protected int doUpdateRows(Serializable id, PersistentCollection collection, SharedSessionContractImplementor session) throws HibernateException {
        return 0;
    }

    @Override
    public void updateRows(PersistentCollection collection, Serializable id, SharedSessionContractImplementor session) throws HibernateException {
        // Do nothing
    }

    @Override
    public void deleteRows(PersistentCollection collection, Serializable id, SharedSessionContractImplementor session) throws HibernateException {
        // Do nothing
    }

    @Override
    public void remove(Serializable id, SharedSessionContractImplementor session) throws HibernateException {
        // Do nothing
    }

}
